﻿<?php
/**
 ***********************************************************************************************
 * Role updater plugin for Admidio
 *
 * Version 1.0 - Compatible with Admidio version 3.1
 *
 * With the help of this plugin you can easily create mailing lists from
 * checkbox fields in the user data.
 * 
 * Licensed under the MIT License (MIT)
 *
 * Copyright (c) 2016 - Matthias Jentsch - info@matthias-jentsch.de
 * 
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 *
 ***********************************************************************************************
 */

// create path to plugin
$plugin_folder_pos = strpos(__FILE__, 'adm_plugins') + 11;
$plugin_file_pos   = strpos(__FILE__, 'role_updater.php');
$plugin_folder     = substr(__FILE__, $plugin_folder_pos+1, $plugin_file_pos-$plugin_folder_pos-2);

// include the global variables
if(!defined('PLUGIN_PATH'))
{
    define('PLUGIN_PATH', substr(__FILE__, 0, $plugin_folder_pos));
}
require_once(PLUGIN_PATH. '/../adm_program/system/common.php');

// include the language file and the configuration of the plugin
$gL10n->addLanguagePath(PLUGIN_PATH. '/'.$plugin_folder.'/languages');
require_once(PLUGIN_PATH. '/'.$plugin_folder.'/config.php');

// create a simple html page with some text
$page = new HtmlPage();
$page->addJavascriptFile($g_root_path.'/adm_program/libs/jquery/jquery.min.js');
$page->setHeadline($gL10n->get('PLG_ROLEUPDATER_HEADLINE'));
$page->addHtml('<strong>'.$gL10n->get('PLG_ROLEUPDATER_WELCOME').'</strong><br />');

// get all mailing lists
$mailingListRoles = $gDb->query('SELECT rol_name, rol_id FROM '.TBL_CATEGORIES.' INNER JOIN '.TBL_ROLES.' ON cat_id = rol_cat_id WHERE cat_type=\'ROL\' AND cat_name=\''.$plg_roleupdater_maling_list_category.'\' ORDER BY rol_name');
while ($mailingListRole = $mailingListRoles->fetch())
{
	$page->addHtml($mailingListRole['rol_name'].': ');
	
	// delete members from the role
	$delete = $gDb->query('DELETE FROM '.TBL_MEMBERS.' WHERE mem_rol_id = '.$mailingListRole['rol_id'].' AND mem_usr_id IN (SELECT usd_usr_id FROM '.TBL_USER_FIELDS.' INNER JOIN '.TBL_USER_DATA.' ON usf_id = usd_usf_id WHERE usf_name = \''.$mailingListRole['rol_name'].'\' AND usd_value <> \'1\')');
	$page->addHtml($delete->rowCount().' '.$gL10n->get('PLG_ROLEUPDATER_DELETED').' ');
	
	// select missing
	$missing = $gDb->query('SELECT usd_usr_id FROM '.TBL_USER_FIELDS.' INNER JOIN '.TBL_USER_DATA.' ON usf_id = usd_usf_id LEFT JOIN '.TBL_MEMBERS.' ON usd_usr_id = mem_usr_id AND mem_rol_id = '.$mailingListRole['rol_id'].' WHERE usf_name = \''.$mailingListRole['rol_name'].'\' AND usd_value = \'1\' AND mem_rol_id IS NULL');
	if ($missing->rowCount() === 0)
	{
		$page->addHtml('0 '.$gL10n->get('PLG_ROLEUPDATER_ADDED').'<br />');
	}
	else
	{
		$first = true;
		$insertStatement = 'INSERT INTO '.TBL_MEMBERS.' (mem_rol_id, mem_usr_id, mem_begin, mem_end, mem_leader, mem_usr_id_create, mem_timestamp_create, mem_count_guests) VALUES ';
		while ($userId = $missing->fetch())
		{
			if ($first === false)
			{
				$insertStatement = $insertStatement.', ';
			}
			else
			{
				$first = false;
			}
			$insertStatement = $insertStatement.'('.$mailingListRole['rol_id'].', '.$userId['usd_usr_id'].', \''.date('Y-m-d').'\', \'9999-12-31\', 0, 1, \''.date('Y-m-d H:i:s').'\', 0)';
		}
		$insert = $gDb->query($insertStatement);
		$page->addHtml($insert->rowCount().' '.$gL10n->get('PLG_ROLEUPDATER_ADDED').'<br />');
	}
}
$page->addHtml('<strong>'.$gL10n->get('PLG_ROLEUPDATER_GOODBYE').'</strong>');
$page->show();
?>